
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "kysec_dlp/kysec_dlp.h"


static int print_rule(rule *rule)
{
    int i=0;
    if(!rule)
    {
        return -1;
    }
    printf("rule_size=%d\n",rule->rule_size);
    for (i=0;i<rule->rule_size;i++)
    {
        printf("rule%d:%d,%s,%d\n",i+1,rule->app_rules[i].uid,rule->app_rules[i].app_path,rule->app_rules[i].acl);
    }
    return 0;
}

int main(int argc, char *argv[])
{
    int ret=0;
    rule rule_list;  
    rule * file_rule=NULL;
    app_rule app_rule_array[7];  
    char * app_path="/usr/sbin/example_dlp";
    char * wps="/opt/kingsoft/wps-office/office6/wps";
    char * wpp="/opt/kingsoft/wps-office/office6/wpp";
    char * ls="/usr/bin/ls";
    char * vim="/usr/bin/vim.basic";
    char * mkdir="/usr/bin/mkdir";
    char * rm="/usr/bin/rm";
    char * example_dlp="/usr/sbin/example_dlp";

    char * wps_dir="wps";
    //char * wps_file="wps/wps.txt";
    char * wpp_dir="wpp";
    //char * wpp_file="wpp/wpp.txt";

    char * rmfile="/data/security-dir/17ae0311709c53982bcf24e7fb5ae3177bbc3fbf3f504baa163da232029a526c/test/test.txt";

    char dlp_path[PATH_MAX];
    ret = dlp_get_app_common_path(app_path,dlp_path);
    if(ret == ERR_RULE_AND_DLP_PATH_NOT_EXIST)
    {
        printf("%s(%d):dlp_path and rule not exist,ret=%d,dlp_path=%s\n",__FUNCTION__,__LINE__,ret,dlp_path);
    }
    else if(ret == ERR_RULE_NOT_EXIST)
    {
        printf("%s(%d):dlp_path exist,but rule not exist,ret=%d,dlp_path=%s\n",__FUNCTION__,__LINE__,ret,dlp_path);

    }
    else if(ret)
    {
        printf("%s(%d):dlp_get_app_common_path error,ret=%d,dlp_path=%s\n",__FUNCTION__,__LINE__,ret,dlp_path);
    }
    else
    {
        printf("%s(%d):dlp_get_app_common_path success,app_path=%s,dlp_path=%s\n",__FUNCTION__,__LINE__,app_path,dlp_path);
    }

    if(ret)
    {
        app_rule_array[0].uid=USER_EVERYBODY;//USER_EVERYBODY;
        app_rule_array[0].acl=FILE_READ|FILE_WRITE|FILE_DEL;
        app_rule_array[0].app_path=wps;
        app_rule_array[1].uid=USER_EVERYBODY;
        app_rule_array[1].acl=FILE_READ|FILE_WRITE|FILE_DEL;
        app_rule_array[1].app_path=wpp;
        app_rule_array[2].uid=USER_EVERYBODY;
        app_rule_array[2].acl=FILE_READ|FILE_WRITE|FILE_DEL;
        app_rule_array[2].app_path=ls;
        app_rule_array[3].uid=USER_EVERYBODY;
        app_rule_array[3].acl=FILE_READ|FILE_WRITE|FILE_DEL;
        app_rule_array[3].app_path=vim;
        app_rule_array[4].uid=USER_EVERYBODY;
        app_rule_array[4].acl=FILE_READ|FILE_WRITE|FILE_DEL;
        app_rule_array[4].app_path=mkdir;
        app_rule_array[5].uid=USER_EVERYBODY;
        app_rule_array[5].acl=FILE_DEL;
        app_rule_array[5].app_path=rm;
        app_rule_array[6].uid=USER_EVERYBODY;
        app_rule_array[6].acl=FILE_WRITE|FILE_DEL;
        app_rule_array[6].app_path=example_dlp;
        rule_list.rule_size=7;
        rule_list.app_rules=app_rule_array;

        ret=dlp_create_common_path(&rule_list,dlp_path);
        if(ret)
        {
            printf("%s(%d):dlp_create_common_path error,ret=%d\n",__FUNCTION__,__LINE__,ret);
            return ret;
        }
        else
        {
            printf("%s(%d):dlp_create_common_path success\n",__FUNCTION__,__LINE__);
        }
    }

    app_rule_array[0].uid=USER_EVERYBODY;
    app_rule_array[0].acl=FILE_READ|FILE_WRITE|FILE_DEL;
    app_rule_array[0].app_path=wps;
    app_rule_array[1].uid=USER_EVERYBODY;
    app_rule_array[1].acl=FILE_READ;
    app_rule_array[1].app_path=wpp;
    rule_list.rule_size=2;
    rule_list.app_rules=app_rule_array;    
    ret=dlp_set_common_file_rule(wps_dir,&rule_list);
    if(ret)
    {
        printf("%s(%d):dlp_set_common_file_rule error,ret=%d\n",__FUNCTION__,__LINE__,ret);
        return ret;
    }
    else
    {
        printf("%s(%d):dlp_set_common_file_rule success\n",__FUNCTION__,__LINE__);
    }

    app_rule_array[0].uid=1000;
    app_rule_array[0].acl=FILE_READ;
    app_rule_array[0].app_path=wps;
    app_rule_array[1].uid=1000;
    app_rule_array[1].acl=FILE_READ|FILE_WRITE|FILE_DEL;
    app_rule_array[1].app_path=wpp;
    rule_list.rule_size=2;
    rule_list.app_rules=app_rule_array;    
    ret = dlp_set_common_file_rule(wpp_dir,&rule_list);
    if(ret)
    {
        printf("%s(%d):dlp_set_common_file_rule error,ret=%d\n",__FUNCTION__,__LINE__,ret);
        return ret;
    }
    else
    {
        printf("%s(%d):dlp_set_common_file_rule success\n",__FUNCTION__,__LINE__);
    }  
    
    ret = dlp_get_common_file_rule(wps_dir,&file_rule);
    if(ret)
    {
        printf("%s(%d):dlp_get_common_file_rule error,ret=%d,relative_file=%s\n",__FUNCTION__,__LINE__,ret,wps_dir);
    }
    else
    {
        printf("%s(%d):dlp_get_common_file_rule success,relative_file=%s\n",__FUNCTION__,__LINE__,wps_dir);
        print_rule(file_rule);
        dlp_free_rule(file_rule);
        file_rule=NULL;
    }

    ret = dlp_get_common_file_rule(wpp_dir,&file_rule);
    if(ret)
    {
        printf("%s(%d):dlp_get_common_file_rule error,ret=%d,relative_file=%s\n",__FUNCTION__,__LINE__,ret,wpp_dir);
    }
    else
    {
        printf("%s(%d):dlp_get_common_file_rule success,relative_file=%s\n",__FUNCTION__,__LINE__,wpp_dir);
        print_rule(file_rule);
        dlp_free_rule(file_rule);
        file_rule=NULL;
    }

    ret = dlp_get_common_file_rule("/",&file_rule);
    if(ret)
    {
        printf("%s(%d):dlp_get_common_file_rule error,ret=%d,relative_file=%s\n",__FUNCTION__,__LINE__,ret,wpp_dir);
    }
    else
    {
        printf("%s(%d):dlp_get_common_file_rule success,relative_file=%s\n",__FUNCTION__,__LINE__,"/");
        print_rule(file_rule);
        dlp_free_rule(file_rule);
        file_rule=NULL;
    }

    if(remove(rmfile))
    {
        printf("%s(%d): remove:%s error,errno=(%d: %s)\n",__FUNCTION__,__LINE__,rmfile,errno, strerror(errno));
    }
    else
    {
        printf("%s(%d): remove:%s success\n",__FUNCTION__,__LINE__,rmfile);
    }

    return 0;
}